#include <EEPROM.h>
#include <flash_stm32.h>
/*
   _===_ _           _                 ______ _     _             _ _ _
  |  ___| |         | |                | ___ (_)   | |           (_) | |
  | |__ | | ___  ___| |_ _ __ ___ _____| |_/ /_  __| | ___  _   _ _| | | ___ _   _ _ __
  |  __|| |/ _ \/ __| __| '__/ _ \_____| ___ \ |/ _` |/ _ \| | | | | | |/ _ \ | | | '__|
  | |___| |  __/ (__| |_| | | (_) |    | |_/ / | (_| | (_) | |_| | | | |  __/ |_| | |
  \____/|_|\___|\___|\__|_|  \___/     \____/|_|\__,_|\___/ \__,_|_|_|_|\___|\__,_|_|


  Exemple d'utilisation du port UART
  Électro-Bidouilleur, Juin 2017
*/
//------------------------------------------------------------------------------
// Définitions et instructions au compilateur

#define LF 10                           // line feed (ASCII-10)

//------------------------------------------------------------------------------
// Procédure de configuration du STM32, style arduino

void setup()
{
  Serial.begin(9600);                             // configuration du port série (broches A9 et A10)
  Serial.setTimeout(10);                          // Délai d'attente maximum de 10 milli-secondes de la fonction serial.read
  ...
  ...
}

//------------------------------------------------------------------------------
// Boucle principale, style arduino

void loop()
{
   // Définition des variables
  String atten_input = "";                                              // La chaîne de caractères contenant la fréquence
  char temp_char;                                                       // Caractère temporaire

   // Boucle principale
  while (true)                                                          // Boucle perpétuelle
  {
     // Validation d'un changement d'atténuation par port série

    Serial.println("Entrez l'attenuation (dB): ");                                            // Afficher la demande d'atténuation à l'usager sur le port série
 
    temp_char = Serial.read();                                          // Lire un caractère du port série.  Expiration de la lecture après 10ms
    
    if (temp_char >= 10 && temp_char <= 127)                            // Validation du caractère lu (est-ce un caractère?)
    {
      if (temp_char != LF) atten_input += temp_char;                    // Ajouter le caractère à la chaîne de commande si la fin de la commande (délimitée par LF (ASCII 10)) n'est pas reçue
      else      // Fin de la commande reçue ici
      {
        Serial.print("   Attenuation entree (dB): ");                   // Afficher sur le port série l'atténuation reçue 
        ...
        ...
      }
    }  
  }
}
